-- End of the Line (quest line that is!)
local oldcomp, oldquest, newcomp, newquest

local qids = TourGuide and TourGuide.QIDmemo or setmetatable({}, { -- Taken quite stealthily from tourguide, steal his cache if its there (possibly create a library later)
	__index = function(t,i)
		local v = tonumber(i:match("|Hquest:(%d+):"))
		t[i] = v
		return v
	end,
})


local _, npcname, npcid
local function AddNPCWaypoints(qid, qname)
	--qid,sharable,level,reqlev,stype,sname,sid,etype,ename,eid,exp,rep,series
	bol,_,_,_,_,_,_,_,npcname,npcid,_,_,series = LightHeaded:GetQuestInfo(qid)
	if not bol or npcname == "" or not npcid == "" then return end --check bol to find out if LH has the quest.
	local uids,  note = "", "[End] "..npcname..": "..qname
	
	local i = 0
	for c,z,x,y in LightHeaded:IterateNPCLocs(tonumber(npcid)) do
		i = i + 1
		if i > 5 then break end

		if TomTom then
			assert(type(TomTom.AddZWaypoint) == "function", "NPC locations are not supported in this version of TomTom.")
			uids = format("%s %d", uids, TomTom:AddZWaypoint(c, z, x, y, note, false))
		end
	end
	return uids
end

	

local compquests, oldcompquests = {}, {}
local function QuestUpdate()
	-- old becomes the new and new becomes the old
	oldcompquests, compquests = compquests, oldcompquests
	
	--Scan quests
    for id = 1, GetNumQuestLogEntries() do
        local qname,_,_,_,header,_,iscomp = GetQuestLogTitle(id)
        if not header and iscomp == 1 then
		-- Get the questsid
		local link = GetQuestLink(id)
		local qid = link and qids[link]
		if qid then
			compquests[qid] = oldcompquests[qid] or AddNPCWaypoints(qid, qname) --Add waypoints if not there
		end
        end
    end
	
	-- Now compare the old comp quests to the new
	for k, v in pairs(oldcompquests) do
		if not compquests[k] then
			for uid in string.gmatch(v, "%S+") do
				TomTom:RemoveWaypoint(tonumber(uid))
			end
		end
		oldcompquests[k] = nil
	end
end

local f = CreateFrame("Frame")
f:RegisterEvent("QUEST_LOG_UPDATE")
f:SetScript("OnEvent", QuestUpdate)
QuestUpdate()



